org.apache.datasketches.filters.bloomfilter

## Class DirectBitArrayR

- java.lang.Object
- - org.apache.datasketches.filters.bloomfilter.DirectBitArrayR

    public class DirectBitArrayR
    extends Object

This class can maintain the BitArray object off-heap.

### Field Summary

Fields
`protected static long` `DATA_OFFSET`
`protected int` `dataLength_`
`protected static long` `MAX_BITS`
`protected static long` `NUM_BITS_OFFSET`
`protected long` `numBitsSet_`
`protected org.apache.datasketches.memory.WritableMemory` `wmem_`

### Constructor Summary

Constructors
`protected` `DirectBitArrayR(int dataLength, long storedNumBitsSet, org.apache.datasketches.memory.Memory mem)`

### Method Summary

All Methods Static Methods Instance Methods Concrete Methods
`protected long` `getLong(int arrayIndex)`
`boolean` `hasMemory()`
`boolean` `isDirect()`
`protected boolean` `isDirty()`
`boolean` `isReadOnly()`
`protected static String` `printLong(long val)`
`protected void` `setLong(int arrayIndex, long value)`
`String` `toString()`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Field Detail

#### NUM_BITS_OFFSET

    protected static final long NUM_BITS_OFFSET

See Also:
  Constant Field Values

#### DATA_OFFSET

    protected static final long DATA_OFFSET

See Also:
  Constant Field Values

#### dataLength_

    protected final int dataLength_

#### wmem_

    protected final org.apache.datasketches.memory.WritableMemory wmem_

#### numBitsSet_

    protected long numBitsSet_

#### MAX_BITS

    protected static final long MAX_BITS

See Also:
  Constant Field Values

### Constructor Detail

#### DirectBitArrayR

    protected DirectBitArrayR(int dataLength,
                              long storedNumBitsSet,
                              org.apache.datasketches.memory.Memory mem)

### Method Detail

#### isDirty

    protected boolean isDirty()

#### getLong

    protected long getLong(int arrayIndex)

#### hasMemory

    public boolean hasMemory()

#### isDirect

    public boolean isDirect()

#### isReadOnly

    public boolean isReadOnly()

#### setLong

    protected void setLong(int arrayIndex,
                           long value)

#### toString

    public String toString()

Overrides:
  `toString` in class `Object`

#### printLong

    protected static String printLong(long val)